#import <Foundation/Foundation.h>

#pragma mark Notification Strings
#pragma mark -
NSString *RInterpreterWillWriteToConsole;
NSString *RInterpreterDidWriteToConsole;

NSString *RInterpreterWillWritePrompt;
NSString *RInterpreterDidWritePrompt;

NSString *RInterpreterWillReadFromConsole;
NSString *RInterpreterDidReadFromConsole;

NSString *RInterpreterDidFinishStartingInterpreter;
NSString *RInterpreterWillStartEvaluating;
NSString *RInterpreterDidStartEvaluating;
NSString *RInterpreterDidFinishEvaluating;

NSString *RInterpreterWillChangeConsole;
NSString *RInterpreterDidChangeConsole;

NSString *RInterpreterShowHelpForFunction;
NSString *RInterpreterOpenDevice;
NSString *RInterpreterShowHelpFiles;

@interface RInterpreter : NSObject {
	NSMutableArray *libraryPaths;
	BOOL            standardReader;
	NSTimer        *periodic;
}
+ (RInterpreter*)sharedInterpreter;

- (BOOL)hasActiveConsole;
- (void)setConsoleDocument:(id)aConsole buffer:(CFMutableAttributedStringRef)aBuffer copy:(BOOL)shouldCopy;

- (void)setPromptAttributes:(NSDictionary*)attrs;
- (void)setOutputAttributes:(NSDictionary*)attrs;
- (void)setInputAttributes:(NSDictionary*)attrs;


- (NSDictionary*)inputAttributes;

- (void)appendInput:(NSString*)aStr evaluate:(BOOL)shouldEval;


- (void)setHomeDirectory:(NSString*)homeDir;
- (void)run;
- (void)stop;

- (void)setUsesStandardReader:(BOOL)aBool;
- (BOOL)usesStandardReader;

//A bit of a hack, but until R can have multiple evaluators this is how it gets done.
- (void)setSuppressOutput:(BOOL)aBool;
- (BOOL)suppressOutput;

- (BOOL)shouldAddToHistory;

@end
